#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct{
  char ime[51];
  int bodovi;
  int golrazlika; //dodatno smo stavili gol razliku
}klub;

/*Funkcija koja nam povezuje ime kluba sa struktorom u kojoj drzimo podatke za taj klub*/
unsigned nadji_klub(char* imek, klub** l, unsigned* n)
{
  unsigned i;

  for(i=0; i<*n; i++){
    if(!strcmp(imek, (*l)[i].ime))
      return i;
  }

  *l=(klub*)realloc(*l,++*n*sizeof(klub));
  strcpy((*l)[i].ime,imek);
  (*l)[i].bodovi=0;
  (*l)[i].golrazlika=0;

  return i;
}

int main(void){
  FILE *in=fopen("tekstualne_datoteke/nogomet.txt","rt"), *out=fopen("tekstualne_datoteke/nogomet.csv","wt");
  klub *svi=NULL;
  char klub1[51], klub2[51];
  unsigned brkl=0,gol1,gol2,i,j;

  /*Kraci nacin za provjeru jesu li datoteke dobro otvorene*/
  if(!in||!out)
    return printf("Greska pri otvaranju!\n");

  while(fscanf(in," %[^:=]:%[^:=]=%u:%u",klub1,klub2,&gol1,&gol2)>0){
    i=nadji_klub(klub1,&svi,&brkl);
    j=nadji_klub(klub2,&svi,&brkl);

    /*Obradjujemo utakmicu dodavanjem bodova*/
    if(gol1>gol2)
      svi[i].bodovi+=3;
    else if(gol1<gol2)
      svi[j].bodovi+=3;
    else{
      svi[i].bodovi++;
      svi[j].bodovi++;
    }

    /*Obradjujemo gol razliku*/
    svi[i].golrazlika+=gol1-gol2;
    svi[j].golrazlika+=gol2-gol1;
  }

  /*Sortiranje po bodovima pa potom po gol razlici*/
  for(i=0; i<brkl-1; i++){
    for(j=i+1; j<brkl; j++){
        int pom=svi[i].bodovi-svi[j].bodovi;
        if(pom<0 || (pom==0 && svi[i].golrazlika<svi[j].golrazlika)){
        klub tmp=svi[i];
        svi[i]=svi[j];
        svi[j]=tmp;
      }
    }
  }

  /*Upisivanje u datoteku out*/
  for(i=0; i<brkl; i++){
    fprintf(out, "%d;%s;%d;%d\n", i+1, svi[i].ime, svi[i].golrazlika, svi[i].bodovi);
  }

  free(svi);

  fclose(in);
  fclose(out);

  return 0;
}


